﻿//
// Copyright (c) 2015, MindFusion LLC - Bulgaria.
//

using System;
using System.Collections;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Input;


namespace MindFusion.Reporting.Wpf.Samples.CS.ListBinding
{
	/// <summary>
	/// Interaction logic for RatingViewer.xaml
	/// </summary>
	public partial class RatingViewer : UserControl
	{
		static RatingViewer()
		{
			BitmapImage image = new BitmapImage();
			image.BeginInit();
			image.UriSource = new Uri("Images/Star.png", UriKind.Relative);
			image.EndInit();
			StarImage = image;

			image = new BitmapImage();
			image.BeginInit();
			image.UriSource = new Uri("Images/StarDisabled.png", UriKind.Relative);
			image.EndInit();
			StarDisabledImage = image;

			image = new BitmapImage();
			image.BeginInit();
			image.UriSource = new Uri("Images/StarMid.png", UriKind.Relative);
			image.EndInit();
			StarMidImage = image;
		}

		public RatingViewer()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Gets or sets the rating to display.
		/// </summary>
		public double Rating
		{
			get { return (double)GetValue(RatingProperty); }
			set { SetValue(RatingProperty, value); }
		}

		public static readonly DependencyProperty RatingProperty =
			DependencyProperty.Register("Rating", typeof(double), typeof(RatingViewer),
			new PropertyMetadata(OnRatingChanged));

		private static void OnRatingChanged(object sender, DependencyPropertyChangedEventArgs e)
		{
			(sender as RatingViewer).OnRatingChanged((double)e.NewValue);
		}

		private void OnRatingChanged(double newValue)
		{
			star1.Source = newValue < 2 ? (1 < newValue ? StarMidImage : StarDisabledImage) : StarImage;
			star2.Source = newValue < 4 ? (3 < newValue ? StarMidImage : StarDisabledImage) : StarImage;
			star3.Source = newValue < 6 ? (5 < newValue ? StarMidImage : StarDisabledImage) : StarImage;
			star4.Source = newValue < 8 ? (7 < newValue ? StarMidImage : StarDisabledImage) : StarImage;
			star5.Source = newValue < 10 ? (9 < newValue ? StarMidImage : StarDisabledImage) : StarImage;
		}


		private static ImageSource StarImage;
		private static ImageSource StarDisabledImage;
		private static ImageSource StarMidImage;
	}
}
